#ifndef XML_OPERT_HEADER
#define XML_OPERT_HEADER

#include <string>
#include <tinyxml2.h>
#include <vector>
#include "../public_def.h"

typedef tinyxml2::XMLElement element;
class CXmlOpr
{
public:
    CXmlOpr();
    ~CXmlOpr();

public:
    bool     open(const std::string& xml_path);
    void     set_baseinfo(const OprBase& base);
    bool     parse_xml(std::vector<element*>& vec);
    void     insert_brother_node(element* brother, element* newer);
    element* copy_element(element* ele);
    bool     save();

private:
    tinyxml2::XMLDocument doc_{};
    OprBase               opr_base_{};
    std::string           xml_path_{};
    element*              parent_node_{};
};

#endif